import regex as re
import csv
from glob import glob

# Get raw package text from latex file
def extract_text(filename,index):

    #Open file
    data = open(filename).read()

    #Strip comments
    badworkps = re.findall(r'%\\begin{workp}(.*?)\\end{workp}', data, re.S)
    for bwp in badworkps:
        n_bwp = "%\\begin{workp}" + bwp + "\\end{workp}"
        data = data.replace(n_bwp,"")

    badworkps = re.findall(r'% \\begin{workp}(.*?)\\end{workp}', data, re.S)
    for bwp in badworkps:
        n_bwp = "% \\begin{workp}" + bwp + "\\end{workp}"
        data = data.replace(n_bwp,"")

    # Extract work packages
    workps = re.findall(r'\\begin{workp}(.*?)\\end{workp}', data, re.S)

    # Add index
    results = []
    for i,wp in enumerate(workps):
        myitem = {"index":str(index)+"."+str(i+1),"wp":wp}
        results.append(myitem)
    
    return results

# Format the work packages into a list of data
def format_wp(index,wp_s):
    name = wp_s.split("[")[1].split("]")[0]

    if wp_s.split("}\n")[-1] == "":
        text = wp_s.split("}\n")[1].split("\wpin")[0].lstrip().rstrip() 
    else:
        text = wp_s.split("}\n")[-1].split("\wpin")[0].lstrip().rstrip()
    wpin = wp_s.split("\wpin")[1].split("\wpout")[0].rstrip()[1:-1]
    wpout = wp_s.split("\wpout")[1].split("}\n")[0][1:]
    return [index,name,text,wpin,wpout]


#Get filenames, and sort
filenames = glob("*.tex")
filenames.sort()

# Extract all the work packages from the files
workps = []
for i,filename in enumerate(filenames):
    workps += extract_text(filename,i+1)

labels = ["Index","Name","Text","Inputs","Deliverables"]
table = [labels]

#Format the wps
for wp in workps:
    formatted_wp = format_wp(wp["index"],wp["wp"])
    table.append(formatted_wp)

#Write to csv
with open('work_packages.csv', 'w', newline='') as f:
    writer = csv.writer(f)
    writer.writerows(table)